"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function forEach(tree, fn) {
    var _a;
    fn(tree.value);
    if ((_a = tree === null || tree === void 0 ? void 0 : tree.children) === null || _a === void 0 ? void 0 : _a.length) {
        tree.children.forEach(child => {
            forEach(child, fn);
        });
    }
    return tree;
}
exports.forEach = forEach;
function map(tree, fn) {
    var _a;
    const node = {
        value: fn(tree.value, tree.children)
    };
    if ((_a = tree === null || tree === void 0 ? void 0 : tree.children) === null || _a === void 0 ? void 0 : _a.length) {
        node.children = tree.children.map(child => map(child, fn));
    }
    return node;
}
exports.map = map;
function flatten(tree) {
    function flattenRec(acc, node) {
        acc.push(node.value);
        if (node.children) {
            acc.concat(...node.children.map(child => flattenRec(acc, child)));
        }
        return acc;
    }
    return flattenRec([], tree);
}
exports.flatten = flatten;
function flatMap(tree, fn) {
    return flatten(map(tree, fn));
}
exports.flatMap = flatMap;
